package universe
package animal

trait InteractWithAnimals extends Animal {

  /** global event triggered when another animal is reached */
  evt animalReached[Animal] = (targetReached && (_.isInstanceOf[Animal])) map ((be: BoardElement) => Animal.asAnimal(be).get)

  /** event triggered when an animal of the same species is reached */
  evt sameSpeciesReached[Animal] = animalReached && sameSpecies _

  /** event triggered when an animal of another species is reached */
  evt otherSpeciesReached[Animal] = animalReached && (a => !sameSpecies(a))

  def sameSpecies(a: Animal): Boolean

}

// vim: set ts=4 sw=4 et:
