package universe
package gui

import animal._

import scala.swing._
import javax.swing.ImageIcon

trait HerbivoreRenderer extends GuiBoard {
  abstract override def renderElement(be: BoardElement) =
    be match {
      case h: Herbivore =>
        val icon = 
          if(!h.isFertile)
            getClass.getResource("/img/little-sheep.png")
          else if(h.isMale)
            getClass.getResource("/img/male-sheep.png")
          else
            getClass.getResource("/img/female-sheep.png")
        val description =
          "Age: " + h.age + "\nGender: " + (if(h.isMale) "M" else "F") + "\nEnergy: " + h.energy

        new Label(null, new ImageIcon(icon, description), Alignment.Center)
      case _ => super.renderElement(be)
    }
}

// vim: set ts=4 sw=4 et:
