package universe
package animal

import scala.util._

import universe.handler.FemaleShouldGiveBirthHandler

trait Female extends Animal with FemaleShouldGiveBirthHandler {

  // @JVH protected evt shouldGiveBirth[Unit] = afterExec(get_older) && ((_: Any) => child != null && age > child_birth)

  // @JVH begin shouldGiveBirth  
  val female_shouldGiveBirth_subscribers=new scala.collection.mutable.HashSet[FemaleShouldGiveBirthHandler]

  def subscribe_female_shouldGiveBirth(subscriber:FemaleShouldGiveBirthHandler) = {
    female_shouldGiveBirth_subscribers+=subscriber
  }

  def unsubscribe_female_shouldGiveBirth(subscriber:FemaleShouldGiveBirthHandler) = {
    female_shouldGiveBirth_subscribers-=subscriber
  }
  
  def send_female_shouldGiveBirth() = {
    female_shouldGiveBirth_subscribers.foreach(_.handle_femaleShouldGiveBirth)  
  }
  
  // trigger like the declarative event but a bit different
  override def after_get_older() {
    super.after_get_older()

    if (child!=null && age>child_birth) {
      send_female_shouldGiveBirth()
    }
  }

  // @JVH end


  val isMale = false

  override protected def energyLossFactor = if(child != null) 2/3 else super.energyLossFactor

  // @JVH shouldGiveBirth += onShouldGiveBirth _
  override def appear={
    subscribe_female_shouldGiveBirth(this) // @JVH
    super.appear
  }
  // @JVH begin  this was missing
  override def die() {
    unsubscribe_female_shouldGiveBirth(this) 
    super.die
  }
  // @JVH end

  def handle_femaleShouldGiveBirth()={
    onShouldGiveBirth
  }

  def onShouldGiveBirth() { 
    giveBirth(4)
    child = null
    child_birth = 0
  }

  def conceiveChildWith(father: Animal) {
    val range = childRange(father)
    val maxAge = childMaxAge(father)
    
    val chld = createChild(range, maxAge)

    child = chld
    child_birth= age + pregnancy_time
  }

  protected def createChild(range: Int, maxAge: Int): Animal

  protected def childRange(father: Animal) : Int ={
    return childIntprop(father.range,this.range,1.2)
  }

  protected def childMaxAge(father: Animal) : Int ={
    return childIntprop(father.maxAge,this.maxAge,1.2)
  }

  // used to inherit int val from parents with some random
  // the factor bigger than one allow values more extreme then
  // those from the parents
  protected def childIntprop(father_prop: Int, mother_prop : Int, factor : Double ) : Int ={
    val propDiff = (father_prop - mother_prop).abs
    val propAvg = ((father_prop + mother_prop + 0.5) / 2).toInt
    val sign=if (Random.nextBoolean) 1 else -1
    propAvg + sign * Random.nextInt(1 + (factor * propDiff).toInt)
  }

  // variable for the womb
  var child:Animal = null
  var child_birth: Int = 0
  
  val pregnancy_time = 10

  override def isFertile = (child == null) && super.isFertile
  
  // the mother puts the child on the board
  def giveBirth(childRange:Int=5): Boolean = {
    if (child == null || child_birth > age) {
      false
    } else {
      val baby_pos = find_free_around(childRange)
      if (baby_pos == null)
        false
      else
        board.moveTo(baby_pos,child)
    }
  }

}

// vim: set ts=4 sw=4 et:
